Subject: Re: [PATCH/RFC] l10n: de.po: translate 39 new messages

From: Christian Stimming <[email-masked]>
Date: Wed, 17 Apr 2013 17:35:35 +0200

Am Mittwoch, 17. April 2013, 10:09:29 schrieb Thomas Rast:
> >> >  msgid "The bundle contains this ref:"
> >> >  msgid_plural "The bundle contains these %d refs:"
> >> > 
> >> > -msgstr[0] "Das Paket enthält %d Referenz"
> >> > -msgstr[1] "Das Paket enthält %d Referenzen"
> >> > +msgstr[0] "Das Paket enthält diese Referenz:"
> >> > +msgstr[1] "Das Paket enthält diese %d Referenzen:"
> >> 
> >> The msgstr[0] must still contain a %d conversion specifier (which will
> >> be filled with the number 1) even though the translated sentence
> >> wouldn't need the 1 anymore. The previous msgstr[0] was correct; the
> >> English singular msgid
> >> is not.
> > 
> > That made me wonder, too. I've played around a bit with this, and it
> > seems to be OK as long as one of those strings contain at least one
> > format specifier.
> 
> C printf() only knows about the number and types of arguments from the
> format string, so *ignoring* arguments is not a problem for correctness.

Indeed both of you are correct and I learned something new. 

http://stackoverflow.com/questions/3578970/passing-too-many-arguments-to-
printf

where the second answer quotes  Online C Draft Standard (n1256), section 
7.19.6.1, paragraph 2: "If the format is exhausted while arguments remain, the 
excess arguments are evaluated (as always) but are otherwise ignored."

Hence, it is indeed safe to skip unneeded conversion specifiers both in 
general ngettext messages and also in their respective translation. This is an 
explanation which has yet to be added to ngettext's documentation.

Best Regards,

Christian